<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Tiling Transforms</TITLE>
<link href="transform_5.html" rel=Next>
<link href="transform_3.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_3.html">previous</A>, <A HREF="transform_5.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC4" HREF="transform_toc.html#TOC4">Tiling Transforms</A></H2>

<P>
The tiling transformation, in the general case, maps an n-deep loop nest
into a 2n-deep loop nest where the inner n loops include only a small
fixed number of iterations.

</P>
<P>
The method <CODE>tile_transform</CODE> in the <CODE>loop_transform</CODE> class
is used to generate the tiling transformations.  
The loop nest can be separated into regions, where each region is tiled
separately.
Each region can optionally be coalesced.  For a region of size r,
if coalescing is turned off, then the region is transformed into 2r loops.
If coalescing is turned on for the region, then it is transformed into
2r - 1 loops.
A region of size one will not be transformed, regardless of whether
it is coalesced.

</P>
<P>
The <CODE>tile_transform</CODE> method takes four parameters:

</P>
<DL COMPACT>

<DT><CODE>trip</CODE>
<DD>
An array of integer trip sizes, one for each loop.  This specifies the size
of the block for the corresponding loop.

<DT><CODE>nregions</CODE>
<DD>
The number of tiling regions.

<DT><CODE>coalesce</CODE>
<DD>
An array of booleans, one for each region.  
If <CODE>true</CODE> then the corresponding region is coalesced.

<DT><CODE>first</CODE>
<DD>
An index array giving the position of the first loop in
the region.  This array must have its last element (at position
nregions) set to the nesting depth of the entire loop nest.
</DL>

<P>
In addition, the tiling transformation requires that the boolean array
of doalls in the <CODE>loop_transform</CODE> class be filled in. See section <A HREF="transform_2.html#SEC2">Loop Transformations</A>.

</P>
<P>
The method returns a boolean to indicate if the transformation was
successful.
In general, given the following region:

</P>

<PRE>
for (i = lb0; i &#60;= ub0; i++) {
    for (j = lb1(i); j &#60;= ub1(i); j++) {
        ...
    }
}
</PRE>

<P>
Using blocks of size <CODE>b0</CODE> for the <CODE>i</CODE> loop, and blocks of size
<CODE>b1</CODE> for the <CODE>j</CODE> loop, the tiling transformation turns the
code into:

</P>

<PRE>
for (i_tile = lb0; i_tile &#60;= ub0; i_tile += b0) {
    for (j_tile = lb1(i_tile);
         j_tile &#60;= max(ub1(i_tile), ub1(i_tile+b0-1)); j_tile += b1) {

        for (i = i_tile; i &#60;= min(ub0, i_tile+b0-1), i++) {
            for (j = max(lb1(i), j_tile); 
                 j &#60;= min(ub1(i), j_tile+b1-1); j++) {
                        ...
            }
        }
    }
}
</PRE>

<P>
In this example, we assume the lower and upper bounds of the loops are
increasing functions of the enclosing loops plus a constant (the
resulting code for decreasing functions is slightly different).  
If possible, the lower and upper bounds are calculated at compile-time.
Otherwise, the max and min instructions in the bounds are performed at
run-time.

</P>

<UL>
<LI><A HREF="transform_5.html#SEC5">Simple Examples</A>: Examples of tiling one perfectly-nested region
<LI><A HREF="transform_6.html#SEC6">Multiple Regions</A>: How to tile with multiple regions 
<LI><A HREF="transform_7.html#SEC7">Non-perfectly Nested Loops</A>: How non-perfectly nested loops are transformed
</UL>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_3.html">previous</A>, <A HREF="transform_5.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
